#include "gameportapp.h"
#include "gamestickmessage.h"
#include "gamestickthread.h"
#include "gameportview.h"
#include <stdio.h>

BTSGamePortWindow::BTSGamePortWindow(BRect frame)
	: BWindow(frame,"Game Port", B_TITLED_WINDOW,0)
{
	fGameStickThread = new BTSGameStickThread();
	fGamePortView = new BTSGamePortView();
	AddChild(fGamePortView);
}

bool
BTSGamePortWindow::QuitRequested()
{
	// Get rid of joystick input
	delete fGameStickThread;

	be_app->PostMessage(B_QUIT_REQUESTED);
	return(TRUE);
}


void
BTSGamePortWindow::DisplayData(BMessage *msg)
{
	fGamePortView->DisplayData(msg);
}

//=======================================================
//
//=======================================================
BTSGamePortApp::BTSGamePortApp()
	: BApplication('*GPA')
{
}

void
BTSGamePortApp::ReadyToRun()
{
	BRect frame(30,30,320,320);
	fWindow = new BTSGamePortWindow(frame);
	fWindow->Show();
}

bool
BTSGamePortApp::QuitRequested()
{
	fWindow->Quit();
	
	return TRUE;
}

void
BTSGamePortApp::MessageReceived(BMessage *message)
{
	#ifdef DEBUG
	printf("BTSGamePortApp::MessageReceived - BEGIN (%d)\n", message->what);
	#endif
	
	switch (message->what) 
	{
		case BTS_GP_INFO:
			fWindow->DisplayData(message);
		break;
		
		default:
			printf("BTSGamePortApp::MessageReceived - Unknown Message Received: %d\n", message->what);
			BApplication::MessageReceived(message);
		break;
	}
	
	#ifdef DEBUG
	printf("GameEngine::MessageReceived - END\n");
	#endif
}
