
#include "gameportview.h"
#include "gamestickmessage.h"
#include <stdio.h>
#include <Looper.h>
#include <StringView.h>
#include <TextControl.h>
#include <Window.h>

BTSGamePortView::BTSGamePortView()
	: BView(BRect(0,0,400,400),"gameportview",B_FOLLOW_NONE,0)
{
	BRect bounds;
	

	// Last X, Y
	bounds.Set(20,30,100,48);
	fLastXView = new BTextControl(bounds,"fLastXView","Last","0.0", 0);
	bounds.Set(110,30,170,48);
	fLastYView = new BTextControl(bounds,"fLastYView",0,"0.0", 0);

	// Zero Values
	bounds.Set(20,50,100,68);
	fZeroXView = new BTextControl(bounds,"fZeroXView","Zero","0.0", 0);
	bounds.Set(110,50,170,68);
	fZeroYView = new BTextControl(bounds,"fZeroYView",0,"0.0", 0);

	// Min Values
	bounds.Set(20,70,100,88);
	fMinXView = new BTextControl(bounds,"fMinXView","Min","0.0", 0);
	bounds.Set(110,70,170,88);
	fMinYView = new BTextControl(bounds,"fMinYView",0,"0.0", 0);

	// Max Values
	bounds.Set(20,90,100,108);
	fMaxXView = new BTextControl(bounds,"fMaxXView","Max","0.0", 0);
	bounds.Set(110,90,170,108);
	fMaxYView = new BTextControl(bounds,"fMaxYView",0,"0.0", 0);

	// Min range
	bounds.Set(20,110,100,128);
	fMinXRangeView = new BTextControl(bounds,"fMinXView","Minrng","0.0", 0);
	bounds.Set(110,110,170,128);
	fMinYRangeView = new BTextControl(bounds,"fMinYView",0,"0.0", 0);

	// Max range
	bounds.Set(20,130,100,148);
	fMaxXRangeView = new BTextControl(bounds,"fMaxXRangeView","Maxrng","0.0", 0);
	bounds.Set(110,130,170,148);
	fMaxYRangeView = new BTextControl(bounds,"fMaxYRangeView",0,"0.0", 0);


/*
	fTimestampView;
*/


	AddChild(fLastXView);
	AddChild(fLastYView);
	AddChild(fZeroXView);
	AddChild(fZeroYView);
	AddChild(fMinXView);
	AddChild(fMinYView);
	AddChild(fMaxXView);
	AddChild(fMaxYView);
	AddChild(fMinXRangeView);
	AddChild(fMinYRangeView);
	AddChild(fMaxXRangeView);
	AddChild(fMaxYRangeView);
}

static void
DisplayFloat(BTextControl *view, const float value)
{
	// If the view doesn't exist, then just return
	if (0 == view)
		return;
		
	char buff[256];
	sprintf(buff, "%4.0f",value);
	
	view->SetText(buff);
}

void
BTSGamePortView::DisplayData(BMessage *msg)
{
	Window()->Lock();
	DisplayFloat(fLastXView, msg->FindFloat("lastx"));
	DisplayFloat(fLastYView, msg->FindFloat("lasty"));
	DisplayFloat(fZeroXView, msg->FindFloat("zerox"));
	DisplayFloat(fZeroYView, msg->FindFloat("zeroy"));
	DisplayFloat(fMinXView, msg->FindFloat("minx"));
	DisplayFloat(fMinYView, msg->FindFloat("miny"));
	DisplayFloat(fMaxXView, msg->FindFloat("maxx"));
	DisplayFloat(fMaxYView, msg->FindFloat("maxy"));
	DisplayFloat(fMinXRangeView, msg->FindFloat("minxrange"));
	DisplayFloat(fMinYRangeView, msg->FindFloat("minyrange"));
	DisplayFloat(fMaxXRangeView, msg->FindFloat("maxxrange"));
	DisplayFloat(fMaxYRangeView, msg->FindFloat("maxyrange"));
	Window()->Unlock();
/*
	AddDouble("timestamp", gameStick.fLastTimestamp);
*/
}

