#ifndef GAMESTICK_H
#define GAMESTICK_H

#include <Joystick.h>
#include "atime.h"

enum EButton {
	BUTTON1 = 1,
	BUTTON2 = 2
};

enum EGamePort {
	GAMEPORT1,
	GAMEPORT2,
	GAMEPORT3,
	GAMEPORT4
};

class BTSGameStick
{
public:
				BTSGameStick();
				BTSGameStick(EGamePort);
		
		void	Initialize(const char *whichone);
		bool	IsValid();
		long	FindZero(float &x, float &y);
		void	Train();
		
		void	Update();
		void	GetPosition(float &x, float &y);
		void	GetAbsolutePosition(short &x, short &y);
		void	GetZeroPosition(short &x, short &y);
		bool	IsButtonPressed(const long whichbutton);
		
	BJoystick	fJoystick;
	bool	fIsValid;
	float	fZeroX;
	float	fZeroY;
	float	fMinX;
	float	fMaxX;
	float	fMinY;
	float	fMaxY;
	
	float	fMinXRange;
	float	fMinYRange;
	float	fMaxXRange;
	float	fMaxYRange;
	float	fLastX;
	float	fLastY;
	double	fLastTimestamp;

protected:
	
private:
	//BTSGameStick(const BTSGameStick &);			// No copy constructor
	//BTSGameStick& operator =(const BTSGameStick &);	// No assignment
};


#endif
